Index: palm/trunk/EXAMPLES/bio_meteorology/canyon/INPUT/canyon_p3d
===================================================================
--- palm/trunk/EXAMPLES/bio_meteorology/canyon/INPUT/canyon_p3d	(revision 4126)
+++ palm/trunk/EXAMPLES/bio_meteorology/canyon/INPUT/canyon_p3d	(revision 4126)
@@ -0,0 +1,73 @@
+
+&initialization_parameters
+!
+!-- grid parameters
+!-------------------------------------------------------------------------------
+    nx                         = 39, ! Number of gridboxes in x-direction (nx+1)
+    ny                         = 39, ! Number of gridboxes in y-direction (ny+1)
+    nz                         = 20, ! Number of gridboxes in z-direction (nz)
+
+    dx                         = 1.0, ! Size of single gridbox in x-direction
+    dy                         = 1.0, ! Size of single gridbox in y-direction
+    dz                         = 1.0, ! Size of single gridbox in z-direction
+
+!
+!-- initialization
+!-------------------------------------------------------------------------------
+    time_utc_init              = 43200.0 !UTC time at model start in seconds starting from midnight. default value 43200.0 (noon). 
+    day_of_year_init           = 172
+    latitude                   = 41.9
+    longitude                  = 12.5
+
+    initializing_actions       = 'set_constant_profiles', ! initial conditions
+
+    ug_surface                 = 0.0, ! u-comp of geostrophic wind at surface
+    vg_surface                 = 0.0, ! v-comp of geostrophic wind at surface
+    pt_surface                 = 300.0, ! initial surface potential temp
+    pt_vertical_gradient       =   0.0,
+                                   1.0, ! piecewise temp gradients
+
+/ ! end of initialization parameter namelist
+
+
+&runtime_parameters
+!
+!-- run steering
+!-------------------------------------------------------------------------------
+    end_time                   = 3600.0, ! simulation time of the 3D model
+
+
+!
+!-- data output
+!-------------------------------------------------------------------------------
+    netcdf_data_format         = 2, ! use NetCDF3
+
+    dt_run_control             = 0.0,    ! output interval for run control
+    dt_data_output             = 60.0,   ! output interval for general data
+    dt_data_output_av          = 60.0,   ! output interval for averaged data
+     
+    data_output                = 'uvem_vitd3dose*_xy_av', 'uvem_vitd3*_xy'
+       
+    section_xy                 = 1,   ! grid index for 2D XY cross sections
+    averaging_interval         = 60.0, ! averaging interval general data
+    !dt_averaging_input         = 5.0,  ! averaging general data sampling rate
+
+
+
+!-------------------------------------------------------------------------------
+!-- Biometeorology PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/biometpar
+!-------------------------------------------------------------------------------
+&biometeorology_parameters
+!
+!-- exposure model parameters
+!-------------------------------------------------------------------------------    
+    uv_exposure              = .TRUE.,   !< .T.=expo model on, .F.=expo model off
+    thermal_comfort          = .FALSE.
+    !consider_obstructions    = .FALSE.,  !< .T.=with obstructions, .F.=unobstructed,                                  
+    !clothing                 =   0,      !< 0=unclothed, 1=summer, 3=winter)
+    !orientation_angle        = 180.0,    !< orientation of front/face of human
+    !turn_to_sun              = .TRUE.,   !< .F.=as orient. angle, .T.=human to sun
+    !sun_in_south             = .FALSE.,  !< .F.=actual pos., .T.=sun in south 
+
+/ ! end of biometeorology parameter namelist 
Index: palm/trunk/EXAMPLES/bio_meteorology/cube_mini/INPUT/cube_mini_p3d
===================================================================
--- palm/trunk/EXAMPLES/bio_meteorology/cube_mini/INPUT/cube_mini_p3d	(revision 4126)
+++ palm/trunk/EXAMPLES/bio_meteorology/cube_mini/INPUT/cube_mini_p3d	(revision 4126)
@@ -0,0 +1,76 @@
+
+&initialization_parameters
+!
+!-- grid parameters
+!-------------------------------------------------------------------------------
+    nx                         = 39, ! Number of gridboxes in x-direction (nx+1)
+    ny                         = 39, ! Number of gridboxes in y-direction (ny+1)
+    nz                         = 20, ! Number of gridboxes in z-direction (nz)
+
+    dx                         = 1.0, ! Size of single gridbox in x-direction
+    dy                         = 1.0, ! Size of single gridbox in y-direction
+    dz                         = 1.0, ! Size of single gridbox in z-direction
+    
+    dt                         = 10.0
+
+!
+!-- initialization
+!-------------------------------------------------------------------------------
+    time_utc_init              = 23200.0 !UTC at start in sec, starting from midnight.
+    day_of_year_init           = 172
+    latitude                   = 52.39 !41.9
+    longitude                  = 9.70! 12.5
+
+
+    initializing_actions       = 'set_constant_profiles', ! initial conditions
+    ug_surface                 = 0.0, ! u-comp of geostrophic wind at surface
+    vg_surface                 = 0.0, ! v-comp of geostrophic wind at surface
+    pt_surface                 = 300.0, ! initial surface potential temp
+    pt_vertical_gradient       =   0.0,
+                                   1.0, ! piecewise temp gradients
+
+/ ! end of initialization parameter namelist
+
+
+
+&runtime_parameters
+!
+!-- run steering
+!-------------------------------------------------------------------------------
+    end_time                   = 3600.0, ! simulation time of the 3D model
+
+
+!
+!-- data output
+!-------------------------------------------------------------------------------
+    netcdf_data_format         = 2, ! use NetCDF3
+
+    dt_run_control             = 0.0,    ! output interval for run control
+    dt_data_output             = 60.0,   ! output interval for general data
+    dt_data_output_av          = 60.0,   ! output interval for averaged data
+     
+    data_output                = 'uvem_vitd3dose*_xy_av', 'uvem_vitd3*_xy'
+       
+    section_xy                 = 1,   ! grid index for 2D XY cross sections
+    averaging_interval         = 60.0, ! averaging interval general data
+    !dt_averaging_input         = 5.0,  ! averaging general data sampling rate
+
+
+
+!-------------------------------------------------------------------------------
+!-- Biometeorology PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/biometpar
+!-------------------------------------------------------------------------------
+&biometeorology_parameters
+!
+!-- exposure model parameters
+!-------------------------------------------------------------------------------    
+    uv_exposure              = .TRUE.,   !< .T.=expo model on, .F.=expo model off
+    thermal_comfort          = .FALSE.
+    !consider_obstructions    = .FALSE.,  !< .T.=with obstructions, .F.=unobstructed,                                  
+    !clothing                 =   0,      !< 0=unclothed, 1=summer, 3=winter)
+    !orientation_angle        = 180.0,    !< orientation of front/face of human
+    !turn_to_sun              = .TRUE.,   !< .F.=as orient. angle, .T.=human to sun
+    !sun_in_south             = .FALSE.,  !< .F.=actual pos., .T.=sun in south 
+
+/ ! end of biometeorology parameter namelist 
Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4125)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4126)
@@ -27,4 +27,8 @@
 ! -----------------
 ! $Id$
+! renamed vitd3_exposure_av into vitd3_dose,
+! renamed uvem_calc_exposure into bio_calculate_uv_exposure
+! 
+! 3885 2019-04-11 11:29:34Z kanani
 ! Changes related to global restructuring of location messages and introduction 
 ! of additional debug messages
@@ -274,6 +278,6 @@
     REAL(wp), DIMENSION(0:71,0:9) ::  radiance_array_temp          = 0.0_wp  !< temporary radiance data
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vitd3_exposure     !< result variable for instantaneous vitamin-D weighted exposures
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vitd3_exposure_av  !< result variable for summation of vitamin-D weighted exposures
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vitd3_exposure  !< result variable for instantaneous vitamin-D weighted exposures
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vitd3_dose      !< result variable for summation of vitamin-D weighted exposures
 
     REAL(wp), DIMENSION(0:35,0:9,0:90) ::  radiance_lookup_table   = 0.0_wp  !< radiance lookup table
@@ -290,5 +294,5 @@
 !
 !-- UVEM PUBLIC variables and methods
-    PUBLIC uvem_calc_exposure, uv_exposure
+    PUBLIC bio_calculate_uv_exposure, uv_exposure
 
 !
@@ -386,7 +390,7 @@
 !
 !-- Calculate UV exposure grid
-    INTERFACE uvem_calc_exposure
-       MODULE PROCEDURE uvem_calc_exposure
-    END INTERFACE uvem_calc_exposure
+    INTERFACE bio_calculate_uv_exposure
+       MODULE PROCEDURE bio_calculate_uv_exposure
+    END INTERFACE bio_calculate_uv_exposure
 
  CONTAINS
@@ -462,8 +466,8 @@
 
           CASE ( 'uvem_vitd3dose*' )
-             IF ( .NOT. ALLOCATED( vitd3_exposure_av ) )  THEN
-                ALLOCATE( vitd3_exposure_av(nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( vitd3_dose ) )  THEN
+                ALLOCATE( vitd3_dose(nysg:nyng,nxlg:nxrg) )
              ENDIF
-             vitd3_exposure_av = 0.0_wp
+             vitd3_dose = 0.0_wp
 
           CASE DEFAULT
@@ -607,8 +611,8 @@
 !--       This is a cumulated dose. No mode == 'average' for this quantity.
           CASE ( 'uvem_vitd3dose*' )
-             IF ( ALLOCATED( vitd3_exposure_av ) )  THEN
+             IF ( ALLOCATED( vitd3_dose ) )  THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
-                      vitd3_exposure_av(j,i) = vitd3_exposure_av(j,i) + vitd3_exposure(j,i)
+                      vitd3_dose(j,i) = vitd3_dose(j,i) + vitd3_exposure(j,i)
                    ENDDO
                 ENDDO
@@ -805,9 +809,9 @@
 
        CASE ( 'uvem_vitd3*' )
-          IF (  .NOT.  uv_exposure )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //     &
-                      'res a namelist &uvexposure_par'
-             CALL message( 'uvem_check_data_output', 'UV0001', 1, 2, 0, 6, 0 )
-          ENDIF
+!           IF (  .NOT.  uv_exposure )  THEN
+!              message_string = 'output of "' // TRIM( var ) // '" requi' //     &
+!                       'res a namelist &uvexposure_par'
+!              CALL message( 'uvem_check_data_output', 'UV0001', 1, 2, 0, 6, 0 )
+!           ENDIF
           IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
              message_string = 'illegal value for data_output: "' //            &
@@ -823,9 +827,9 @@
 
        CASE ( 'uvem_vitd3dose*' )
-          IF (  .NOT.  uv_exposure )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //     &
-                      'res  a namelist &uvexposure_par'
-             CALL message( 'uvem_check_data_output', 'UV0001', 1, 2, 0, 6, 0 )
-          ENDIF
+!           IF (  .NOT.  uv_exposure )  THEN
+!              message_string = 'output of "' // TRIM( var ) // '" requi' //     &
+!                       'res  a namelist &uvexposure_par'
+!              CALL message( 'uvem_check_data_output', 'UV0001', 1, 2, 0, 6, 0 )
+!           ENDIF
           IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
              message_string = 'illegal value for data_output: "' //            &
@@ -835,8 +839,8 @@
           ENDIF
           unit = 'IU/av-h'
-          IF ( .NOT. ALLOCATED( vitd3_exposure_av ) )  THEN
-             ALLOCATE( vitd3_exposure_av(nysg:nyng,nxlg:nxrg) )
+          IF ( .NOT. ALLOCATED( vitd3_dose ) )  THEN
+             ALLOCATE( vitd3_dose(nysg:nyng,nxlg:nxrg) )
           ENDIF
-          vitd3_exposure_av = 0.0_wp
+          vitd3_dose = 0.0_wp
 
        CASE DEFAULT
@@ -1030,5 +1034,5 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   local_pf(i,j,nzb+1) = vitd3_exposure_av(j,i)
+                   local_pf(i,j,nzb+1) = vitd3_dose(j,i)
                 ENDDO
              ENDDO
@@ -1250,5 +1254,5 @@
         ONLY: message_string
 
-    IF ( .NOT. radiation_interactions )  THEN
+    IF ( (.NOT. radiation_interactions) .AND. ( thermal_comfort ) )  THEN
        message_string = 'The mrt calculation requires ' //                     &
                         'enabled radiation_interactions but it ' //            &
@@ -4290,5 +4294,5 @@
 !> Module-specific routine for new module
 !---------------------------------------------------------------------------------------------------------------------!
- SUBROUTINE uvem_calc_exposure
+ SUBROUTINE bio_calculate_uv_exposure
 
     USE indices,                                                                                                      &
@@ -4439,5 +4443,5 @@
     ENDIF
 
- END SUBROUTINE uvem_calc_exposure
+ END SUBROUTINE bio_calculate_uv_exposure
 
  END MODULE biometeorology_mod
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4125)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4126)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! renamed routine to calculate uv exposure
+! 
+! 4111 2019-07-22 18:16:57Z suehring
 ! advc_flags_1 / advc_flags_2 renamed to advc_flags_m / advc_flags_s
 ! 
@@ -545,5 +548,6 @@
 
     USE biometeorology_mod,                                                                        &
-        ONLY:  bio_calculate_thermal_index_maps, thermal_comfort, uvem_calc_exposure, uv_exposure
+        ONLY:  bio_calculate_thermal_index_maps, thermal_comfort, bio_calculate_uv_exposure,       &
+               uv_exposure
 
     USE bulk_cloud_model_mod,                                                                      &
@@ -1704,5 +1708,5 @@
 !--       If required, do UV exposure calculations
           IF ( uv_exposure )  THEN
-             CALL uvem_calc_exposure
+             CALL bio_calculate_uv_exposure
           ENDIF
        ENDIF